
## Sequence predictions

### Prerequisities

* Python >= 3.5

### Usage

```
python predict.py -h
usage: predict.py [-h] [--debug] input output

positional arguments:
  input       input file
  output      output file

optional arguments:
  -h, --help  show this help message and exit
  --debug     print debug info
```

### Algorithm

Program attempts to fit the sequence using linear regression model:
* `a[n] = sum(w[0] + w[1]*a[1] + ... + w[n-1]*a[n-1])`

The reason why linear model works is due to the information transfer between subsequent members.
This idea is borrowed from recurrent neural networks.

If `a[n] = f(a[-n]) + g(n)` then `f(A)` and `g(n)` can be reconstructed from previous members. 
These members contain echoes of the same information.
And such sequence is than only repeated version of self. 

It is possible to predict members of any sequence, as long as model has enough capacity.
However, a problem arises with a posteriori probability of model which decreases with increased complexity. 
In other words, we can always fit some (complex) model to given data,
but the model can hardly be trusted to be the true model under posterior. 
